<?php
/*
Template Name: contact
*/
?>

<?php get_header(); ?>

<!-- content -->

<div id="content">

<?php if (have_posts()) : ?>

	<?php while (have_posts()) : the_post(); ?>

		<?php
		//validate email adress
		function is_valid_email($email)
		{
  			return (eregi ("^([a-z0-9_]|\\-|\\.)+@(([a-z0-9_]|\\-)+\\.)+[a-z]{2,4}$", $email));
		}
		
		//clean up form fields to prevent bcc injection
		function telaweb_safe($value)
		{
			$value = trim(strip_tags(htmlspecialchars($value)));
			$value = preg_replace("/\r/", "", $value);
			$value = preg_replace("/\n/", "", $value);
			return(preg_replace(array("/bcc\:/i","/Content\-Type\:/i","/cc\:/i","/to\:/i"), '', $value));
		}

		//clean up text
		function clean($text)
		{
			return stripslashes($text);
		}

		//encode special chars (in name and subject)
		function encodeMailHeader ($string, $charset = 'UTF-8')
		{
    		return sprintf ('=?%s?B?%s?=', strtoupper ($charset),base64_encode ($string));
		}

		$tela_name    = (!empty($_POST['tela_name']))    ? $_POST['tela_name']    : "";
		$tela_email   = (!empty($_POST['tela_email']))   ? $_POST['tela_email']   : "";
		$tela_url     = (!empty($_POST['tela_url']))     ? $_POST['tela_url']     : "";
		$tela_subject = (!empty($_POST['tela_subject'])) ? $_POST['tela_subject'] : "";
		$tela_message = (!empty($_POST['tela_message'])) ? $_POST['tela_message'] : "";

		$tela_name = telaweb_safe($tela_name);
		$tela_email = telaweb_safe($tela_email);
		$tela_subject = clean($tela_subject);
		$tela_message = clean($tela_message);
		$error_msg = "";
		$send = 0;

		if (!empty($_POST['submit'])) {
			$send = 1;
			if (empty($tela_name) || empty($tela_email) || empty($tela_subject) || empty($tela_message)) {
				$error_msg.= "<p><strong>Please fill in all required fields.</strong></p>\n";
				$send = 0;
			}
			if (!is_valid_email($tela_email)) {
				$error_msg.= "<p><strong>Your email adress failed to validate.</strong></p>\n";
				$send = 0;
			}
		}

		if (!$send) { ?>

			<h2><?php the_title(); ?></h2>
			<?php
				the_content();
				echo $error_msg;
			?>

			<form method="post" action="<?php echo "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; ?>" id="contactform">
				<fieldset>
					<p><label for="tela_name">Name</label> <input type="text" name="tela_name" id="tela_name" value="<?php echo $tela_name; ?>" tabindex="1" /></p>
					<p><label for="tela_email">Email</label> <input type="text" name="tela_email" id="tela_email" value="<?php echo $tela_email; ?>" tabindex="2" /></p>
					<p><label for="tela_url">Url</label> <input type="text" name="tela_url" id="tela_url" value="<?php echo $tela_url; ?>" tabindex="3" /> <em>Optional</em></p>
					<p><label for="tela_subject">Subject</label> <input type="text" name="tela_subject" id="tela_subject" value='<?php echo $tela_subject; ?>' tabindex="4" /></p>
					<p><label for="tela_message">Message</label> <textarea name="tela_message" id="tela_message" cols="45" rows="10" tabindex="5"><?php echo $tela_message; ?></textarea></p>
					<p><input type="submit" name="submit" value="Submit" class="button" tabindex="6" /></p>
				</fieldset>
			</form>

		<?php
		} else {

			$displayName_array	= explode(" ",$tela_name);
			$displayName = htmlentities(utf8_decode($displayName_array[0]));

			$header  = "MIME-Version: 1.0\n";
			$header .= "Content-Type: text/plain; charset=\"utf-8\"\n";
			$header .= "From:" . encodeMailHeader($tela_name) . "<" . $tela_email . ">\n";
			$header .= "Reply-To: " . encodeMailHeader($tela_name) . "<" . $tela_email . ">\n";
			$email_subject	= "[" . get_settings('blogname') . "] " . encodeMailHeader($tela_subject);
			$email_text		= "From......: " . $tela_name . "\n" .
							  "Email.....: " . $tela_email . "\n" .
							  "Url.......: " . $tela_url . "\n\n" .
							  "..........................................................\n" .
							  "Subject...: " . $tela_subject . "\n" .
							  "..........................................................\n\n" .
							  $tela_message;

			if (@mail(get_settings('admin_email'), $email_subject, $email_text, $header)) {
				echo "<h2>Hey " . $displayName . ",</h2><p>thanks for your message! I'll get back to you as soon as possible.</p>";
			} else { 
	  			echo "<p>There was a system error. Your message has not been sent. Please try again later.</p>"; 
			};			

		}
		?>

	<?php endwhile; ?>

<?php endif; ?>

</div>

<!-- /content -->

<?php get_footer(); ?>